// ============================================================================
// Module Name: IPat_SyncVar
// Revision: 20170923a
// Author: Altmo toolbox
// Description:
//  + Double FF synchronizer for reset
// ============================================================================

`timescale 1ps/100fs

module IPat_SyncRst (
    clk,
    rst_n,
    rst_n_sync
);

// parameter ==================================================================

// local parameter ============================================================
localparam LP_UD = 1;	// unit delay to avoid racing

// port definition ============================================================
input	clk;		// clock
input	rst_n;		// reset 0 active
output	rst_n_sync;	// synchronized rst_n output


// register and wire definition ===============================================
reg	r_sync0;
reg	r_sync1;

// logic ======================================================================

always @(posedge clk or negedge rst_n) begin
    if (rst_n == 1'b0) begin
        r_sync0 <= #LP_UD 1'b0;
        r_sync1 <= #LP_UD 1'b0;
    end
    else begin
        r_sync0 <= #LP_UD 1'b1;
        r_sync1 <= #LP_UD r_sync0;
    end
end

assign rst_n_sync = r_sync1;

endmodule
