
// 20171022a
// Sanity check for IPat_GfClkMux.v

`timescale 1ps/100fs

module tb;

// parameter
parameter CYC0 = 100*1000; // clkin[0]
parameter CYC1 =  52*1000; // clkin[1]

parameter P_UD = 1; // unit delay

// clock
reg [1:0] clk;
always #(CYC0/2) clk[0] = ~clk[0];
always #(CYC1/2) clk[1] = ~clk[1];
initial begin
    #(0) clk=0;
end

// clock enable
reg  [1:0] clken;
wire       clkin0;
wire       clkin1;

assign clkin0 = clken[0] & clk[0];
assign clkin1 = clken[1] & clk[1];


// vcd dump
initial begin
    $dumpfile("wave.vcd");
    $dumpvars(0,tb);
end

wire  clkout;
reg   sel;
reg   rst_n;


initial begin
    #(  1*1000*1000) rst_n=0;
    #(  1*1000*1000) sel=0; clken=2'b11;
    #(  1*1000*1000) rst_n=1;
    #(  5*1000*1000) sel=1;
    #(  5*1000*1000) sel=0;
    #(  5*1000*1000) sel=1;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #(  5*1000*1000) sel=$random;
    #( 10*1000*1000) $finish;
end


// dut
IPat_GfClkMux dut (
    .clkin0(clkin0),
    .clkin1(clkin1),
    .clkout(clkout),
    .sel(sel),
    .rst_n(rst_n)
);

endmodule
